/*
 * angular-ui-bootstrap
 * http://angular-ui.github.io/bootstrap/

 * Version: 0.10.0 - 2014-01-14
 * License: MIT
 */
angular.module("ui.bootstrap", ["ui.bootstrap.pagination"]), angular.module("ui.bootstrap.pagination", []).controller("PaginationController", ["$scope", "$attrs", "$parse", "$interpolate", function (a, b, c, d) {
  var e = this, f = b.numPages ? c(b.numPages).assign : angular.noop;
  this.init = function (d) {
    b.itemsPerPage ? a.$parent.$watch(c(b.itemsPerPage), function (b) {
      e.itemsPerPage = parseInt(b, 10), a.totalPages = e.calculateTotalPages()
    }) : this.itemsPerPage = d
  }, this.noPrevious = function () {
    return 1 === this.page
  }, this.noNext = function () {
    return this.page === a.totalPages
  }, this.isActive = function (a) {
    return this.page === a
  }, this.calculateTotalPages = function () {
    var b = this.itemsPerPage < 1 ? 1 : Math.ceil(a.totalItems / this.itemsPerPage);
    return Math.max(b || 0, 1)
  }, this.getAttributeValue = function (b, c, e) {
    return angular.isDefined(b) ? e ? d(b)(a.$parent) : a.$parent.$eval(b) : c
  }, this.render = function () {
    this.page = parseInt(a.page, 10) || 1, this.page > 0 && this.page <= a.totalPages && (a.pages = this.getPages(this.page, a.totalPages))
  }, a.selectPage = function (b) {
    !e.isActive(b) && b > 0 && b <= a.totalPages && (a.page = b, a.onSelectPage({page: b}))
  }, a.$watch("page", function () {
    e.render()
  }), a.$watch("totalItems", function () {
    a.totalPages = e.calculateTotalPages()
  }), a.$watch("totalPages", function (b) {
    f(a.$parent, b), e.page > b ? a.selectPage(b) : e.render()
  })
}]).constant("paginationConfig", {itemsPerPage: 10, boundaryLinks: !1, directionLinks: !0, firstText: "First", previousText: "Previous", nextText: "Next", lastText: "Last", rotate: !0}).directive("pagination", ["$parse", "paginationConfig", function (a, b) {
  return{restrict: "EA", scope: {page: "=", totalItems: "=", onSelectPage: " &"}, controller: "PaginationController", templateUrl: "/public/pages/template/pagination/pagination.html", replace: !0, link: function (c, d, e, f) {
    function g(a, b, c, d) {
      return{number: a, text: b, active: c, disabled: d}
    }

    var h, i = f.getAttributeValue(e.boundaryLinks, b.boundaryLinks), j = f.getAttributeValue(e.directionLinks, b.directionLinks), k = f.getAttributeValue(e.firstText, b.firstText, !0), l = f.getAttributeValue(e.previousText, b.previousText, !0), m = f.getAttributeValue(e.nextText, b.nextText, !0), n = f.getAttributeValue(e.lastText, b.lastText, !0), o = f.getAttributeValue(e.rotate, b.rotate);
    f.init(b.itemsPerPage), e.maxSize && c.$parent.$watch(a(e.maxSize), function (a) {
      h = parseInt(a, 10), f.render()
    }), f.getPages = function (a, b) {
      var c = [], d = 1, e = b, p = angular.isDefined(h) && b > h;
      p && (o ? (d = Math.max(a - Math.floor(h / 2), 1), e = d + h - 1, e > b && (e = b, d = e - h + 1)) : (d = (Math.ceil(a / h) - 1) * h + 1, e = Math.min(d + h - 1, b)));
      for (var q = d; e >= q; q++) {
        var r = g(q, q, f.isActive(q), !1);
        c.push(r)
      }
      if (p && !o) {
        if (d > 1) {
          var s = g(d - 1, "...", !1, !1);
          c.unshift(s)
        }
        if (b > e) {
          var t = g(e + 1, "...", !1, !1);
          c.push(t)
        }
      }
      if (j) {
        var u = g(a - 1, l, !1, f.noPrevious());
        c.unshift(u);
        var v = g(a + 1, m, !1, f.noNext());
        c.push(v)
      }
      if (i) {
        var w = g(1, k, !1, f.noPrevious());
        c.unshift(w);
        var x = g(b, n, !1, f.noNext());
        c.push(x)
      }
      return c
    }
  }}
}]).constant("pagerConfig", {itemsPerPage: 10, previousText: "« Previous", nextText: "Next »", align: !0}).directive("pager", ["pagerConfig", function (a) {
  return{restrict: "EA", scope: {page: "=", totalItems: "=", onSelectPage: " &"}, controller: "PaginationController", templateUrl: "template/pagination/pager.html", replace: !0, link: function (b, c, d, e) {
    function f(a, b, c, d, e) {
      return{number: a, text: b, disabled: c, previous: i && d, next: i && e}
    }

    var g = e.getAttributeValue(d.previousText, a.previousText, !0), h = e.getAttributeValue(d.nextText, a.nextText, !0), i = e.getAttributeValue(d.align, a.align);
    e.init(a.itemsPerPage), e.getPages = function (a) {
      return[f(a - 1, g, e.noPrevious(), !0, !1), f(a + 1, h, e.noNext(), !1, !0)]
    }
  }}
}]);